package constants

import (
	"math"
	"os"
	"time"
)

const (
	EmptyString                              = ""
	EmptyArray                               = "[]"
	FirstItemEmptyStringArray                = "[\"\"]"
	EmptyStatus                              = "Empty Status"
	FilePath                                 = "File Path"
	DirectoryPath                            = "Directory Path"
	Dot                                      = "."
	UpperCaseA                               = 'A'
	UpperCaseZ                               = 'Z'
	LowerCaseA                               = 'a'
	LowerCaseZ                               = 'z'
	LowerCase                                = LowerCaseA - UpperCaseA // c - 'A' + 'a' (ref: https://bit.ly/3mFnUPW)
	UpperCase                                = UpperCaseA - LowerCaseA // c - 'a' + 'A'
	NewLineMac                               = "\n"
	NewLineUnix                              = "\n"
	DefaultLine                              = "\n"
	NewLineHyphenSpace                       = DefaultLine + HyphenSpace
	NewLineEqualSpace                        = DefaultLine + "= "
	NewLineWindows                           = "\r\n"
	Tab                                      = "\t"
	TabV                                     = "\v"
	Hash                                     = "#"
	DoubleHash                               = "##"
	TripleHash                               = "###"
	HashSpace                                = "# "
	DoubleHashSpace                          = "## "
	Space                                    = " "
	Hyphen                                   = "-"
	Semicolon                                = ";"
	Comma                                    = ","
	CommaUnixNewLine                         = ",\n"
	CommaSpace                               = ", "
	CsvJoiner                                = CommaSpace
	SpaceColonSpace                          = " : "
	Pipe                                     = "|"
	QuestionMarkSymbol                       = "?"
	NilString                                = "nil"
	EqualSymbol                              = "="
	DoubleEqualSymbol                        = "=="
	TripleEqualSymbol                        = "==="
	NotEqualSymbol                           = "!="
	JsNotEqualSymbol                         = "!=="
	SqlNotEqualSymbol                        = "<>"
	LeftLessSymbol                           = "<"
	LeftLessEqualSymbol                      = "<="
	LeftGreaterSymbol                        = ">"
	LeftGreaterEqualSymbol                   = ">="
	InvalidNotFoundCase                      = -1
	Zero                                     = 0
	NotImplemented                           = "Not Implemented"
	SingleQuoteSymbol                byte    = '\''
	DoubleQuoteSymbol                byte    = '"'
	SingleQuoteStringSymbol                  = "'"
	DoubleQuoteStringSymbol                  = "\""
	DoubleDoubleQuoteStringSymbol            = "\"\""
	ParenthesisStartSymbol           byte    = '('
	ParenthesisEndSymbol             byte    = ')'
	CurlyStartSymbol                 byte    = '{'
	CurlyEndSymbol                   byte    = '}'
	SquareStartSymbol                byte    = '['
	SquareEndSymbol                  byte    = ']'
	LineFeedUnix                             = '\n'
	CarriageReturn                           = '\r'
	FormFeed                                 = '\f'
	SpaceByte                                = ' '
	TabByte                                  = '\t'
	LineFeedUnixByte                         = '\n'
	CarriageReturnByte                       = '\r'
	FormFeedByte                             = '\f'
	TabVByte                                 = '\v'
	MaxUnit8                         byte    = 255
	OtherPathSeparator                       = "/"
	WindowsPathSeparator                     = "\\"
	WindowsOS                                = "windows"
	LowerCaseFileColon                       = "file:"
	DoubleBackSlash                          = "\\\\"
	TripleBackSlash                          = "\\\\\\"
	BackSlash                                = "\\"
	DoubleForwardSlash                       = "//"
	TripleForwardSlash                       = "///"
	BackwardAndForwardSlashes                = "\\//"
	ForwardSlash                             = "/"
	UriSchemePrefixStandard                  = "file:///"
	UriSchemePrefixTwoSlashes                = "file://"
	Underscore                               = "_"
	Colon                                    = ":"
	Dash                                     = "-"
	DoubleDash                               = "--"
	DoubleUnderscore                         = "__"
	HyphenAngelRight                         = "->"
	GoPath                                   = "GOPATH"
	GoBinPath                                = "GOBIN"
	Go111ModuleEnvironment                   = "GO111MODULE"
	On                                       = "on"
	PathSeparator                            = string(os.PathSeparator)
	DoublePathSeparator                      = PathSeparator + PathSeparator
	Dollar                                   = "$"
	DoubleDollar                             = "$$"
	Percent                                  = "%"
	DoublePercent                            = "%%"
	One                                      = 1
	SemiColon                                = ";"
	Path                                     = "PATH"
	Unix                                     = "Unix OS"
	Windows                                  = "Windows OS"
	SymbolicLinkCreationCommandName          = "ln"
	SymbolicLinkCreationArgument             = "-s"
	Architecture64                           = "X64"
	Architecture32                           = "X32"
	LongPathUncPrefix                        = `\\?\UNC\`
	LongPathQuestionMarkPrefix               = `\\?\`
	SingleHash                               = "#"
	EndOfBlock                               = "}"
	EndOfLineMark                            = ";"
	StartOfBlock                             = "{"
	MinusOne                                 = -1
	InvalidValue                             = -1
	InvalidIndex                             = -1
	InvalidLineNumber                        = -1
	TakeAllMinusOne                          = -1
	NoLimits                                 = -1
	DontCompare                              = -1
	WildcardSymbol                           = "*"
	WildcardChar                             = '*'
	WildcardRune                     rune    = '*'
	ParenthesisStart                         = "("
	ParenthesisEnd                           = ")"
	CurlyStart                               = "{"
	CurlyEnd                                 = "}"
	SquareStart                              = "["
	SquareEnd                                = "]"
	ZeroChar                         byte    = '0'
	NineChar                         byte    = '9'
	HyphenChar                       byte    = '-'
	MaxUnit8Rune                     rune    = 255
	MaxUnit8AsInt16                  int16   = 255
	MaxUnit8AsInt                    int     = 255
	MaxInt16                                 = math.MaxUint16
	MaxInt16AsInt                    int     = math.MaxUint16
	MaxUnit8AsFloat32                float32 = 255
	ParenthesisStartRune             rune    = '('
	ParenthesisEndRune               rune    = ')'
	CurlyStartRune                   rune    = '{'
	CurlyEndRune                     rune    = '}'
	SquareStartRune                  rune    = '['
	SquareEndRune                    rune    = ']'
	ZeroRune                         rune    = '0'
	NineRune                         rune    = '9'
	HyphenRune                       rune    = '-'
	UpperCaseARune                   rune    = 'A'
	UpperCaseZRune                   rune    = 'Z'
	LowerCaseARune                   rune    = 'a'
	LowerCaseZRune                   rune    = 'z'
	LowerCaseRune                    rune    = LowerCaseA - UpperCaseA         // c - 'A' + 'a' (ref: https://bit.ly/3mFnUPW) a - A = 32 also works
	UpperCaseRune                            = UpperCaseARune - LowerCaseARune // c - 'a' + 'A'
	NoElements                               = "{No Element}"
	NoItems                                  = "{No Items}"
	NoItemsSquare                            = "[No Items]"
	NoElementsSquare                         = "[No Element]"
	DoubleNewLine                            = "\n\n"
	DotSymbol                                = "."
	DotChar                          byte    = '.'
	ForwardChar                      byte    = '/'
	BackwardChar                     byte    = '\\'
	AndChar                          byte    = '&'
	PipeChar                         byte    = '|'
	ParenthesisStartChar             byte    = '('
	ParenthesisEndChar               byte    = ')'
	CurlyBraceStartChar              byte    = '{'
	CurlyBraceEndChar                byte    = '}'
	SquareBraceStartChar             byte    = '['
	SquareBraceEndChar               byte    = ']'
	AngleStartChar                   byte    = '<'
	AngleEndChar                     byte    = '>'
	QuestionChar                     byte    = '?'
	CommaChar                        byte    = ','
	ExclamationChar                  byte    = '!'
	HashChar                         byte    = '#'
	DollarChar                       byte    = '$'
	AsteriskChar                     byte    = '*'
	WildcardStarChar                 byte    = '*'
	PlusChar                         byte    = '+'
	MinusChar                        byte    = '-'
	UnderscoreChar                   byte    = '_'
	SingleQuoteChar                  byte    = '\''
	DoubleQuoteChar                  byte    = '"'
	ColonChar                        byte    = ':'
	SemicolonChar                    byte    = ';'
	SpaceChar                        byte    = ' '
	AtChar                           byte    = '@'
	EqualChar                        byte    = '='
	LeftLessChar                     byte    = '<'
	LeftGreaterChar                  byte    = '>'
	DotRune                          rune    = '.'
	ForwardRune                      rune    = '/'
	BackwardRune                     rune    = '\\'
	AndRune                          rune    = '&'
	PipeRune                         rune    = '|'
	CurlyBraceStartRune              rune    = '{'
	CurlyBraceEndRune                rune    = '}'
	SquareBraceStartRune             rune    = '['
	SquareBraceEndRune               rune    = ']'
	AngleStartRune                   rune    = '<'
	AngleEndRune                     rune    = '>'
	QuestionRune                     rune    = '?'
	CommaRune                        rune    = ','
	ExclamationRune                  rune    = '!'
	HashRune                         rune    = '#'
	DollarRune                       rune    = '$'
	AsteriskRune                     rune    = '*'
	PlusRune                         rune    = '+'
	MinusRune                        rune    = '-'
	UnderscoreRune                   rune    = '_'
	SingleQuoteRune                  rune    = '\''
	DoubleQuoteRune                  rune    = '"'
	AtRune                           rune    = '@'
	ColonRune                        rune    = ':'
	SemicolonRune                    rune    = ';'
	SpaceRune                        rune    = ' '
	EqualRune                        rune    = '='
	LeftLessRune                     rune    = '<'
	LeftGreaterRune                  rune    = '>'
	MinusTwo                                 = -2
	MinusThree                               = -3
	MinusFour                                = -4
	Two                                      = 2
	Three                                    = 3
	Four                                     = 4
	Five                                     = 5
	Six                                      = 6
	Seven                                    = 7
	Eight                                    = 8
	Nine                                     = 9
	Ten                                      = 10
	AsteriskSymbol                           = "*"
	PlusSymbol                               = "+"
	TildeSymbol                              = "~"
	TildeChar                        byte    = '~'
	TildeRune                        rune    = '~'
	BrokenLongPathUncPrefix                  = `\?\UNC\`
	BrokenLongPathQuestionMarkPrefix         = `\?\`
	N0                                       = 0
	N1                                       = 1
	N2                                       = 2
	N3                                       = 3
	N4                                       = 4
	N5                                       = 5
	N6                                       = 6
	N7                                       = 7
	N8                                       = 8
	N9                                       = 9
	N10                                      = 10
	N11                                      = 11
	N12                                      = 12
	N13                                      = 13
	N14                                      = 14
	N15                                      = 15
	N16                                      = 16
	N17                                      = 17
	N18                                      = 18
	N19                                      = 19
	N20                                      = 20
	N21                                      = 21
	N22                                      = 22
	N23                                      = 23
	N24                                      = 24
	N25                                      = 25
	N26                                      = 26
	N27                                      = 27
	N28                                      = 28
	N29                                      = 29
	N30                                      = 30
	N31                                      = 31
	N32                                      = 32
	DistributorID                            = "Distributor ID"
	Description                              = "Description"
	Release                                  = "Release"
	Codename                                 = "Codename"
	HyphenA                                  = "-a"
	UnameArgForReleaseInfo                   = "-r"
	ArgumentForReleaseDate                   = "-v"
	LsbCommand                               = "lsb_release"
	UnameCommand                             = "uname"
	Shell                                    = "sh"
	Bash                                     = "bash"
	BinShellCmd                              = "/bin/sh"
	Etc                                      = "/etc/"
	ShellCmdline                             = "sh"
	PerlCmdline                              = "perl"
	MakeCmdline                              = "make"
	Pwsh                                     = "pwsh"
	Cmd                                      = "cmd"
	HypenC                                   = "-c"
	Cd                                       = "cd"
	Pwd                                      = "pwd"
	BashDefaultPath                          = "/bin/bash"
	BashCommandline                          = "bash"
	NonInteractiveFlag                       = "-c"
	NonInteractiveCmdFlag                    = "/c"
	NonInteractivePerlFlag                   = "-e"
	ChmodCommand                             = "chmod"
	RecursiveCommandFlag                     = "-R"
	VersionCommandForCmd                     = "ver.exe"
	CompareEqual                             = 0
	CompareLess                              = -1
	CompareGreater                           = 1
	NilAngelBracket                          = "<nil>"
	CommaRawValueColonSpace                  = ", value: "
	IndexColonSpace                          = "index: "
	CommaIndexColonSpace                     = ", index: "
	N0String                                 = "0" // N refers to number
	N1String                                 = "1"
	N2String                                 = "2"
	N3String                                 = "3"
	N4String                                 = "4"
	N5String                                 = "5"
	N6String                                 = "6"
	N7String                                 = "7"
	N8String                                 = "8"
	N9String                                 = "9"
	N10String                                = "10"
	MaxUint                                  = ^uint(0) // https://stackoverflow.com/a/6878625
	MinUint                                  = 0
	MaxInt                                   = int(MaxUint >> 1) // https://stackoverflow.com/a/6878625, 64 bit 9223372036854775807, 32bit, 2147483647
	MinInt                                   = -MaxInt - 1
	NewLineUnixChar                  byte    = '\n'
	NewLineUnixRune                  rune    = '\n'
	DefaultRangesJoiner                      = ", "
	DoubleQuotationStartEnd                  = `""`
	DoubleQuotation                          = `"`
	SingleQuotationStartEnd                  = `''`
	SingleQuotation                          = `'`
	Backtick                                 = "`"
	BacktickStartEnd                         = "``"
	BacktickSymbol                           = '`'
	BacktickRuneSymbol               rune    = '`'
	CodeQuotation                            = "`"
	CodeQuotationStartEnd                    = "``"
	SpaceWithColon                           = " : "
	CurrentDirDot                            = Dot
	InQuerySuffix                            = " IN (?)"
	SslPort                                  = 443
	PublicPort                               = 80
	Common8080Port                           = 8080
	SpaceHyphenSpace                         = " - "
	HyphenSpace                              = "- "
	SpaceEqualSpace                          = " = "
	SpacePipeSpace                           = " | "
	SpaceUnderscoreSpace                     = " _ "
	SpaceColonEqualSpace                     = " := "
	SpaceCommaSpace                          = " , "
	NewLineSpaceHyphenSpace                  = "\n - "
	NewLineSpaceEqualSpace                   = "\n = "
	NewLineSpacePlusSpace                    = "\n + "
	SpaceHyphenAngelBracketSpace             = " -> "
	NonAsyncSafeRangeSmall                   = 15
	NonAsyncSafeRangeMedium                  = 50
	NonAsyncSafeRangeLarge                   = 100
	FileInfoEachLineJoiner                   = ",\n - "
	IndentFileInfoEachLineJoiner             = "\n   - "
	PrefixKeyword                            = "prefix"
	RelativeKeyword                          = "relative"
	IdKeyword                                = "id"
	OnKeyword                                = "on"
	OffKeyword                               = "off"
	FileKeyword                              = "file"
	LogFileKeyword                           = "log-file"
	HomeKeyword                              = "home"
	UserKeyword                              = "user"
	AppKeyword                               = "app"
	TmpKeyword                               = "tmp"
	WrappedTemplate                          = "{wrapped}"
	BracketsWrappedTemplate                  = "{brackets-wrapped}"
	QuotesWrappedTemplate                    = "{quotes-wrapped}"
	SingleQuotesWrappedTemplate              = "{single-quotes-wrapped}"
	DoubleQuotesWrappedTemplate              = "{double-quotes-wrapped}"
	BacktickQuotesWrappedTemplate            = "{backtick-quotes-wrapped}"
	ParenthesisWrappedTemplate               = "{parenthesis-wrapped}"
	SquareWrappedTemplate                    = "{square-wrapped}"
	CurlyWrappedTemplate                     = "{curly-wrapped}"
	DynamicTemplate                          = "{dynamic}"
	DynamicTemplateTemplate                  = "{dynamic-template}"
	RandomTemplate                           = "{random}"
	InjectTemplate                           = "{inject-template}"
	ValueTemplate                            = "{value}"
	ValueWithFieldsTemplate                  = "{value-fields}"
	ValueJsonTemplate                        = "{value-json}"
	ValueYamlTemplate                        = "{value-yaml}"
	PathPrefixTemplate                       = "{prefix}"
	PathRelativeTemplate                     = "{relative}"
	PathIdTemplate                           = "{id}"
	PathLogFileTemplate                      = "{log-file}"
	PathFileTemplate                         = "{file}"
	PathRootTemplate                         = "{root}"
	PathHomeTemplate                         = "{home}"
	PathUserTemplate                         = "{user}"
	PathRootPrefixTemplate                   = "{root}/{prefix}/"
	PathHomeUserTemplate                     = "{home}/{user}"
	PathHomeUserAppTemplate                  = "{home}/{user}/{app}"
	PathTempDirTemplate                      = "{tmp}/{app}/{pkg}/"
	PathTempTestDirTemplate                  = "{tmp}/{app}/{pkg}/{test}"
	PathVarAppDirTemplate                    = "/var/{app}"                      // app
	PathVarAppDirFileTemplate                = PathVarAppDirTemplate + "/{file}" // app, file
	PathVarLogDirTemplate                    = "/var/log"
	PathVarAppLogDirTemplate                 = "/var/log/{app}/{log-file}"       // app, log-filename
	PrefixRelativeTemplate                   = "{prefix}/{relative}"             // prefix, relative
	PrefixRelativeIdTemplate                 = "{prefix}/{relative}/{id}"        // prefix, relative, id
	PrefixRelativeIdFileTemplate             = "{prefix}/{relative}/{id}/{file}" // prefix, relative, id, file
	PrefixRelativeFormat                     = "%v/%v"                           // prefix, relative
	PrefixRelativeIdFormat                   = "%v/%v/%v"                        // prefix, relative, id
	PrefixRelativeIdFileFormat               = "%v/%v/%v/%v"                     // prefix, relative, id, file
	KeyValShortFormat                        = "%s = %v"                         // Key, Value any
	KeyValJsonFormat                         = "{key: %s, val: %v}"              // Key, Value any
	EnumNameValueFormat                      = "%s[%d]"                          // name, value any
	EnumDoubleQuoteNameValueFormat           = "\"%s\"[%d]"                      // name, value any
	StringEnumNameValueFormat                = "%s"                              // name, value any
	LikeQuerySuffix                          = " LIKE ?"
	SpaceStartedExclamation                  = " started!"
	SpaceEndedExclamation                    = " ended!"
	SpaceFailedExclamation                   = " failed!"
	SpaceErrorColon                          = " error:"
	AndJoiner                                = " AND "
	WhereClauseStart                         = " WHERE "
	DoubleStars                              = "**"
	Export                                   = "export"
	ProductName                              = "Cimux"
	ProductNameLower                         = "cimux"
	RedisDefaultAddress                      = "localhost:6379"
	DefaultConcurrency                       = 10
	DefaultMaxTrySmall                       = 3
	DefaultMaxTry                            = 5
	DefaultMaxTryLarge                       = 10
	DefaultMaxDepth                          = 50
	DefaultMaxDepthSmall                     = 10
	DefaultRecursiveMaxDepth                 = 255
	DefaultRecursiveMaxDepthLarge            = 2048
	DefaultMaxLevel                          = 8
	DefaultMaxLevelLarge                     = 64
	DefaultWait                              = 800 * time.Millisecond
	DefaultWaitLong                          = 1 * time.Minute
	DefaultWaitLongLong                      = 2 * time.Minute
	DefaultWaitFast                          = 500 * time.Millisecond
	DefaultWaitFastest                       = 300 * time.Millisecond
	DurationDay                              = 24 * time.Hour
	DurationWeek                             = 7 * DurationDay
	DurationMinute                           = 1 * time.Minute
	DurationMonth                            = 30 * DurationDay
	DurationYear                             = 365 * DurationDay
	SourceLower                              = "source"
	Source                                   = "Source"
	DestinationLower                         = "destination"
	Destination                              = "Destination"
	FromLower                                = "from"
	ToLower                                  = "to"
	From                                     = "From"
	To                                       = "To"
	Left                                     = "Left"
	Right                                    = "Right"
	LeftLower                                = "left"
	RightLower                               = "right"
)
